/**
* Created by thinkzhan
* 作用： 根据config.md生成mock-rule.js, 供devserver proxy用
* 产出： 形如 module.exports = [{
                  path: "/query/id",
              target: "http://127.0.0.1:3033/api/"
                },{
                  path: "/save/id",
              target: "http://127.0.0.1:3033/api/"
                },]
**/

'use strict';

const fs = require('fs'),
    path = require('path');

//代理url,本项目中默认依赖于外层3033端口server
const mock = 'http://127.0.0.1:3033/api/';

const proj = process.argv[2].slice(1);

const sourceFile = path.resolve(__dirname, `${proj}/config.md`),
    distFile =   path.resolve(__dirname, `${proj}/mock-rule.js`);
    
const tplFile =  path.resolve(__dirname, '../tasks/tpl/send.tpl'),
    routerFile =  path.resolve(__dirname, `${proj}/api.js`);

let page = [];
page.push('module.exports = [\n');

let page2 = [];
page2.push(
  `'use strict';
let resData;
module.exports = (Router) => { 

`
);

let source = fs.readFileSync(sourceFile, 'UTF-8');

let tpl = fs.readFileSync(tplFile, 'UTF-8');;


// 匹配  /APP/test2 @get @json
source = String(source).replace(/(\/\b\S+)(\s+\@(\S+)\s+\@(\S+))*/g, (s, $1, $2,$3, $4) => {
    let obj = {
      url: $1,
      method: $3 || 'get',
      action: $4 || 'json'
    };
    // 替换<!--word--->
    page2.push(String(tpl).replace(/\<\!\-\-([^(\-\-\>)]+)\-\-\>/g, (s, $1, $2) =>{
            return obj[$1]; 
          }
    ));
    page2.push('\n\n');
  
    return ` { path: "${$1}",
      target: "${mock}"
    },`
  }
);

page.push(source);
page.push(']');

// 生成webpack devserver proxy文件
fs.writeFileSync(distFile, page.join(''), 'UTF-8');

page2.push(
`
  return Router;
};
`);

if(!fs.existsSync(routerFile)) {

  // 生成 expres server router文件
  fs.writeFileSync(routerFile, page2.join(''), 'UTF-8');

} else {
   throw new Error('api.js文件已存在，init中止防止覆盖！');
}
