/**
 * Created by thinkzhan
 */

'use strict';

const webpack = require('webpack');
const config = require('./webpack.base.config');
const HtmlWebpackPlugin = require('html-webpack-plugin');
const ExtractTextPlugin = require('extract-text-webpack-plugin');
const fs = require('fs');

config.output.publicPath = 'http://127.0.0.1:3033/APP/dist/';                        // 资源路径,根据需要可改为cdn地址
config.output.filename = '[name].[hash].js';                 // 带hash值的入口js名称
config.output.chunkFilename = '[name].[hash].chunk.js';      // 带hash值的路由js名称

config.plugins = (config.plugins || []).concat([
    new ExtractTextPlugin("[name].[hash].css",{ allChunks : true,resolve : ['modules'] }),       // 提取带hash值的css名称
    new webpack.optimize.CommonsChunkPlugin('vendors', 'vendors.[hash].js'),                     // 提取带hash值的第三方库名称
    new webpack.DefinePlugin({
        'process.env': {
            NODE_ENV: '"production"'
        }
    }),
    new webpack.optimize.UglifyJsPlugin({                                                         // 压缩文件
        compress: {
            warnings: false
        }
    }),
    new HtmlWebpackPlugin({                                                                        // 构建html文件
        filename: '../index_prod.html',
        template: './src/template/index.html',
        inject: 'body'
    })
]);

// // 写入环境变量
// fs.open('./src/config/env.js', 'w', function (err, fd) {
//     var buf = 'module.exports = "production";';
//     fs.write(fd,buf,0,buf.length,0,function(err,written,buffer){});
// });

module.exports = config;
