'use strict';
const express = require('express');
const bodyParser = require('body-parser');
const multer = require('multer'); 

const app = express();
const router = express.Router();

const port = 3033;
//当前项目
const cur_proj = 'APP';


app.use(bodyParser.json()); // for parsing application/json
app.use(bodyParser.urlencoded({ extended: true })); // for parsing application/x-www-form-urlencoded

// app.all('*', function(req, res, next) {
//     res.header("Access-Control-Allow-Origin", "*");
//     res.header("Access-Control-Allow-Headers", "X-Requested-With");
//     res.header("Access-Control-Allow-Methods","PUT,POST,GET,DELETE,OPTIONS");
//     res.header("X-Powered-By",' 3.2.1')
//     res.header("Content-Type", "application/json;charset=utf-8");
//     next();
// });

// 静态资源
app.use(`/${cur_proj}`, express.static(`${__dirname}/${cur_proj}/`));
// 充当生成环境server
app.get('/*', function(req, res, next) {
	//res.type('html'); 
    res.sendFile(`${__dirname}/${cur_proj}/index_prod.html`,{});
})

app.engine('.html', require('ejs').__express);
app.set('view engine', 'html');

// proxy接口路由
require(`./API/${cur_proj}/index`).forEach(function(Router) {
    app.use('/api', Router);
    app.use('/', Router);
})

app.listen(port);

module.exports = app;
