var fs = require('fs');
var path = require('path');
var _ = require('lodash');

module.exports = {
	exist: function (filePath) {
		return fs.existsSync(filePath);
	},

	isEmpty: function (dir) {
		return fs.existsSync(dir) && fs.readdirSync(dir).length > 0;
	},

	isDir: function (filePath) {
		return fs.existsSync(filePath) && fs.statSync(filePath).isDirectory();
	},

	copy: function (src, dst) {
		var srcCtx = fs.readFileSync(src, 'utf8');
		fs.writeFileSync(dst, srcCtx);
	},

	copyDir: function (src, dst) {
		var that = this;
		if (that.isDir.call(that, src)) {
			if (!fs.existsSync(dst)) {
				fs.mkdirSync(dst);
			}
		}
		var files = fs.readdirSync(src);
		_.each(files, function (name) {
			var srcPath = path.join(src, name);
			var destPath = path.join(dst, name);

			if (that.isDir.call(that, srcPath)) {
				that.copyDir.call(that, srcPath, destPath)
			} else {
				that.copy.call(that, srcPath, destPath);
			}
		});
	}

}